// This program was prepared by the Regents of the University of California at 
// Los Alamos National Laboratory (the University) under contract No. W-7405-ENG-36 
// with the U.S. Department of Energy (DOE). All rights in the program are reserved 
// by the DOE and the University.  Permission is granted to the public to copy and 
// use this software without charge, provided that this Notice and any statement of 
// authorship are reproduced on all copies.  Neither the U.S. Government nor the 
// University makes any warranty, express or implied, or assumes any liability or 
// responsibility for the use of this software.

#ifndef __UNIVERSAL_OUT
#define __UNIVERSAL_OUT

// A class for portable output of small messages
// (i.e. to the status bar, terminal, whatever).
// The interface is universal, but the implementation
// is platform dependant.

#include <string>

class univout_terminator{
};

class univout{
private:
	std::string buffer;

	void flush();
public:

	univout& operator << (const univout_terminator &m_endl);
	univout& operator << (const univout &m_out);
	univout& operator << (const std::string &m_text);
	univout& operator << (const char &m_char);
	univout& operator << (const int &m_int);
	univout& operator << (const unsigned int &m_uint);
	univout& operator << (const float &m_float);
	univout& operator << (const double &m_double);
	univout& operator << (const long &m_long);

	#ifdef _MAC_OSX 
    univout& operator << (const size_t &m_long);
	#endif // _MAC_OSX 
};

static univout_terminator uout_endl;

extern univout uout;

#endif //__UNIVERSAL_OUT
